app.storeFiles = Ext.extend(Ext.data.JsonStore, {
  sort: function(fieldName, dir) {				
				var field = this.fields.get(fieldName), name = field.name,
				    sortInfo = this.sortInfo || null,
    				sortToggle = this.sortToggle ? this.sortToggle[name] : null;
								
				if (!field)
				  return;
						
				if (!dir) {
						if (sortInfo && sortInfo.field == name) 
								dir = (this.sortToggle[name] || 'ASC').toggle('ASC', 'DESC');
						else 
								dir = field.sortDir;
				}
				
				this.sortInfo = {field: name, direction: dir};
				this.sortToggle[name] = dir;
				
				var sorters = [{field: 'is_dir', direction: 'DESC'}, {field: 'middleware', direction: 'DESC'}, {field: fieldName, direction: dir}];					 
    
				this.multiSortInfo = {
						sorters: sorters,
						direction: dir
				};

    this.hasMultiSort = true;
				this.applySort();
				
				this.fireEvent('datachanged', this);
								
				return true;
		}
});

app.FileManager = Ext.extend(Ext.Container, {
  iconCls: 'x-tab-fm',
				
		refresh: function(arg){
    var o = {
						params: {
								cmd: 'ls'
						}, 
						scope: this,
						success: this.updateFilesList,
						failure: function() {
								this.fmActions.enable();
								this.sbFiles.clearStatus();
						}
				};										
				
				arg = arg || {};
				
				var a = {};
				
				if (arg.action == 'back' || arg.action == 'forward') {
					 var m = arg.action == 'back' ? this.btnBack.menu.items : this.btnForward.menu.items, 
						    step = arg.step || 1;
						if (m.getCount() >= step) {
								o.action = arg.action;
								o.step = step;
							 a = m.get(step-1).st; 
						} else
						  return;
				} else if (arg.action == 'refresh') 
				  a = this.fmCurState;
		  else
				  a.action = 'goto';
    
				arg = Ext.apply(arg, a);
    
				if (!arg.dir)
				  arg.dir = this.fmCurState.dir || this.fmHome;
							
 			o.st = arg;
				o.action = arg.action;
				delete o.st.action;
				
				o.params.middleware = arg.middleware;
				o.params.dir = arg.middleware ? arg.grid_task_id + '/' + arg.grid_dir : arg.dir;
				
				if (o.st.search) 
						Ext.apply(o.params, o.st.search, {search: 1});
							
				this.fmActions.disable();
				Ext.Ajax.request(o);
		},
		
		loadProfiles: function(profiles) {
		  this.profilesPanel.loadProfiles(profiles);				
		},
		
		loadClusterPartitions: function(a){
			 this.formLaunch.loadClusterPartitions(a);
		},
		
		setHome: function(s) {
			 this.fmHome = s;
				this.refresh({dir: s});
		},
		
		initComponent: function(){
		  this.defaultFileTypeClass = 'unknown';
		  
				this.fileTypeClasses = {
						'.7z': 'archive', '.bz2': 'archive', '.gz': 'archive', '.rar': 'archive', '.tar': 'archive', '.tgz': 'archive', '.zip': 'archive', 
						'.png': 'image', '.gif': 'image', '.jpg': 'image', 
						'.txt': 'txt', 
						'.doc': 'word', 
						'.xls': 'excel',
						'.txt': 'txt', '.log': 'txt', 
						'.pdf': 'pdf', 
						'.html': 'html', '.htm': 'html',
						'.conf': 'settings'
				};
				
    this.fmHome = '';
				this.fmCurState = {}; // current state: dir, middleware, grid_dir, grid_task, grid_task_id, search (expr, mtime, atime)
				
				this.fmClipboard = [];
				this.fmClipboardAction = '';	
    
				this.winFileAttributes;
				this.winUpload;
				this.winSearch;
				this.winViewer;		
				
				var filenameTest = /^[\w\d\_\ \-\.]+$/;																			

		  Ext.apply(Ext.form.VTypes, {
						filename: function(val, field) {
								return filenameTest.test(val);
				  },
				  filenameText: ~'Ім\'я файла чи директорії має складатись з літер, цифр та знаків: \'_\', \'-\', \'.\''~,
				  filenameMask: filenameTest
		  });
 
	   this.fileModeFormat = function(x) {
						var y = x % 10,
						    s = (y & 4 ? 'r' : '-') + (y & 2 ? 'w' : '-') + (y & 1 ? 'x' : '-');
						x = Math.floor(x/10);
						y = x % 10;
						s = (y & 4 ? 'r' : '-') + (y & 2 ? 'w' : '-') + (y & 1 ? 'x' : '-') + s;
						x = Math.floor(x/10);	
						y = x % 10;
						s = (y & 4 ? 'r' : '-') + (y & 2 ? 'w' : '-') + (y & 1 ? 'x' : '-') + s;
						return s;
				}
    
				this.extension	=	function (s) {
						var x = (s + '').match(/\.\w+$/);
						return x ? x[0] : '.';
				}
		
    var self = this;
				
    this.updateFilesList = function(response, opts, responseDecoded) {												
				  // here we user responseDecoded because it works for file uploads
						var i, o = response.responseJSON || responseDecoded, mi, A, B,
						    hmi = self.fmCurState.dir ? {
												text: self.fmCurState.dir,
												st: self.fmCurState,
												handler: self.historyMIClick
										} : false;
						
						if (opts.action == 'back' || opts.action == 'forward') {
							 A = opts.action == 'back' ? self.btnForward : self.btnBack;
								B = opts.action == 'back' ? self.btnBack : self.btnForward;
						  A.menu.insert(0, hmi);
								for (i = 1; i <= opts.step; i++) {
									 mi = B.menu.items.get(0);
										if (i < opts.step)
										  A.menu.insert(0, {
											   text: mi.text,
														st: mi.st,
														handler: self.historyMIClick
												})
										B.menu.remove(mi);
								}
						} else if (opts.action == 'goto' && hmi) {
								self.btnForward.menu.removeAll();
								self.btnBack.menu.insert(0, hmi);								
						} 

						if (Ext.isObject(opts.st))
  						self.fmCurState = Ext.applyIf(opts.st, {dir: self.fmHome});
					 						
						var ls = o.ls || {};
						for (i = 0; i < ls.length; i++) 
								ls[i].type = ls[i].d ? '' : self.extension(ls[i].f).toLowerCase();

      self.storeFiles.loadData(ls);
						
						var s = [{field: 'middleware', direction: 'DESC'}, {field: 'is_dir', direction: 'DESC'}],
						    st = self.storeFiles.getSortState()
						if (st != undefined)
						  s.push(st);
						
					//	self.storeFiles.sort(s);
						
						self.tfCurrentDir.setValue(self.fmCurState.middleware ? 
																							 									self.fmCurState.grid_task + (self.fmCurState.grid_dir ?  '/' + self.fmCurState.grid_dir : '') : 
																																	self.fmCurState.dir);
						self.formLaunch.setWorkDir(self.fmCurState.dir);
						self.fmActions.enable();
						self.sbFiles.clearStatus();
				}
				
				this.historyMIClick = function(mi) {			
					 self.refresh({
							 action: mi.parentMenu.direction,
								step: mi.parentMenu.items.indexOf(mi) + 1
						});
				}
				
				this.fmActions = {
						refresh: new Ext.Action({
								disabled: true,
								iconCls: 'x-action-refresh',
								handler: function() {
									 self.refresh({action: 'refresh'})
								}
						}),
						up: new Ext.Action({
								disabled: true,
								iconCls: 'x-action-up',
								tooltip: ~'На рівень вище'~,
								handler: function(){
									 var o = {action: 'goto'};
									 if (self.fmCurState.middleware) {
												if (self.fmCurState.grid_dir) {
												  var f = self.fmCurState.grid_dir.match(/(.*)\//);
												  o.grid_dir = f ? f[1] : '';
														o.middleware = self.fmCurState.middleware;
														o.grid_task = self.fmCurState.grid_task;
														o.grid_task_id = self.fmCurState.grid_task_id;
												} else { // leave grid task
													 o.dir = self.fmCurState.dir;
												}
								  } else if (self.fmCurState.search)
										  o.dir = self.fmCurState.dir;
										else
										  o.dir = self.fmCurState.dir.match(/(.*)\//)[1];
										self.refresh(o);
								}
						}),
						home: new Ext.Action({
								disabled: true,
								iconCls: 'x-action-home',
								tooltip: ~'Домашня тека'~,
								handler: function(){
										self.refresh({action: 'goto', dir: self.fmHome});
								}	
						}),
						goto: new Ext.Action({
								disabled: true,
								iconCls: 'x-action-goto',
								tooltip: ~'Перейти в локальну теку'~,
								handler: function(){
										self.refresh({action: 'goto', dir: self.tfCurrentDir.getValue()});
								}							  
						}),
						back: new Ext.Action({
								disabled: true,
								iconCls: 'x-action-back',
								tooltip: ~'Назад'~,
								menu: {
									 direction: 'back',
										items: []
								},
								handler: function(){
										self.refresh({action: 'back'});
								}
						}),
						forward: new Ext.Action({
								disabled: true,
								iconCls: 'x-action-forward',
								tooltip: ~'Вперед'~,
								menu: {
									 direction: 'forward',
									 items: []
								},
								handler: function(){
										self.refresh({action: 'forward'});
								}
						}),
						newFile: new Ext.Action({
								disabled: true,
								iconCls: 'x-action-newfile',
								handler: function(){
										Ext.Msg.show({
												title: ~'Створення файлу'~, 
												msg: String.format(~'Введіть назву нового файлу в<br />{0}'~, self.fmCurState.dir), 
												icon: Ext.MessageBox.QUESTION,
												iconCls: 'x-action-newfile',
												prompt: true,
												buttons: {ok: true, cancel: true},
												fn: function (btn, fn, opt) {
														if (btn == 'ok' && fn) {
																var f = self.storeFiles.findExact('name', fn) > -1;
																
																if (filenameTest.test(fn) && !f)
																		self.fmActions.view.execute(fn, true);
															 else {
																	 var e = (f ? ~'Файл з таким ім\'ям вже існує'~ : 
																											   	~'Ім\'я файла чи директорії має складатись з літер, цифр та знаків: \'_\', \'-\', \'.\''~)
																  Ext.Msg.show({
																				buttons: Ext.Msg.OK, 
																				icon: Ext.Msg.ERROR,
																				iconCls: '',
																				title: ~'Помилка'~,
																				msg: e
																		});
																}
														}
												}												  
										});
								}
						}),
						newFolder: new Ext.Action({
								disabled: true,
								iconCls: 'x-action-newfolder',
								tooltip: ~'Створення директорії'~,
								handler: function (b, e) {
										Ext.Msg.show({
												title: ~'Створення директорії'~, 
												msg: String.format(~'Введіть назву нової директорії в<br />{0}'~, self.fmCurState.dir), 
												icon: Ext.MessageBox.QUESTION,
												iconCls: 'x-action-newfolder',
												prompt: true,
												buttons: {ok: true, cancel: true},
												fn: function (btn, text, opt) {
														if (btn == 'ok' && text) {
																if (filenameTest.test(text)) {
																		self.fmActions.disable();
																		Ext.Ajax.request({
																				params: {
																						cmd: 'mkdir', 
																						dir: self.fmCurState.dir,
																						newdir: text
																				},							
																				success: self.updateFilesList
																		});
																} else
																		Ext.Msg.show({
																				buttons: Ext.Msg.OK, 
																				icon: Ext.Msg.ERROR,
																				iconCls: '',
																				title: ~'Помилка'~,
																				msg: ~'Ім\'я файла чи директорії має складатись з літер, цифр та знаків: \'_\', \'-\', \'.\''~
																		});
														}
												}												  
										});
								}	
						}),
						del: new Ext.Action({
								disabled: true,		
								iconCls: 'x-action-delete',
								tooltip: ~'Видалити виділену директорію чи файл'~,
								disabled: true,
								handler: function(){
										var c = self.gridFiles.getSelectionModel().getCount();
										Ext.Msg.show({
												title: ~'Видалення файлів'~,
												msg: String.format(~'Видалити {0} файлів?'~, c),
												iconCls: false,
												icon: Ext.MessageBox.WARNING,
												buttons: {yes: true, no: true},
												fn: function(btn) {
														if (btn == 'yes') {
																var i, fs = [], rs = self.gridFiles.getSelectionModel().getSelections();
																for (i = 0; i < rs.length; i++)
																		fs.push(self.fmCurState.dir + '/' + rs[i].data['name']);
																self.fmActions.disable();
																Ext.Ajax.request({
																		params: {
																				cmd: 'rm', 
																				dir: self.fmCurState.dir,
																				'files[]': fs
																		},
																		//st: self.fmCurState,
																		success: self.updateFilesList
																});
														}		
												}		
										})
								}
						}),
						upload: new Ext.Action({
								disabled: true,		
								iconCls: 'x-action-upload',
								tooltip: ~'Виберіть один чи кілька файлів для закачування'~,
								handler: function(){
										if (!self.winUpload) {
												self.winUpload = new Ext.Window({
														title: ~'Закачати файли'~,
														modal: true,
														minWidth: 600,
														width: 600,
														layout: 'fit',
														closeAction: 'hide',
														iconCls: 'x-action-upload',
														items: [{
																xtype: 'form',
																url: 'modules/_.php',
          						method: 'POST',
						          baseParams: {
								          cmd: 'upload_files'
          						},		  																
																fileUpload: true,
																autoHeight: true,
																frame: true,
																labelWidth: 150,
																items: [{
																  xtype: 'fileuploadfield',
										        fieldLabel: ~'Виберіть один чи кілька файлів'~,
																		multiple: true,
										        name: 'file[]',
										        anchor: '100%',
																		allowBlank: false,
																		listeners: {
																			 fileselected: function(ff, newval) {
																					 
																				}
																		}
															 }]
														}],
														buttons: [{
														  text: ~'Закачати'~,
																handler: function(){
																	 var form = self.winUpload.items.items[0];
																		form.getForm().submit({
																				timeout: 120000,
																		  params: {
																					 dir: self.fmCurState.middleware ? 
																							 			self.fmCurState.grid_task + (self.fmCurState.grid_dir ?  '/' + self.fmCurState.grid_dir : '') : 
																											self.fmCurState.dir,
																						m: self.fmCurState.middleware
																				},
																				//st: self.fmCurState,
																				success: function(form, action) {
																					 self.updateFilesList('', action.options, action.result);
																						self.winUpload.hide();
																				}
																		});
																}
														},{
															 text: ~'Відміна'~,
																handler: function(){
																	 self.winUpload.hide();
																}
														}]
												});
										}
										
										self.winUpload.show();
								}
						}),
						zip:	new Ext.Action({
								disabled: true,
								icon: 'images/icons/compress.png',
								tooltip: ~'Архівувати виділені файли чи директорії'~,
								handler: function(){
								  Ext.Msg.show({
												title: ~'Створення директорії'~, 
												msg: String.format(~'Введіть назву нової директорії в<br />{0}'~, self.fmCurState.dir), 
												icon: Ext.MessageBox.QUESTION,
												iconCls: 'x-action-newfolder',
												prompt: true,
												buttons: {ok: true, cancel: true},
												fn: function (btn, text, opt) {
													 if (btn == 'ok' && text) {
															 if (filenameTest.test(text)) {
																	 var i, fs = [], rs = self.gridFiles.getSelectionModel().getSelections();
																  for (i = 0; i < rs.length; i++)
																	  	fs.push(rs[i].data.name);
																		self.fmActions.disable();
																		Ext.Ajax.request({
																				params: {
																						cmd: 'zip', 
																						dir: self.fmCurState.dir,
																						zip_name: text,
																						'files[]': fs
																				},							
																				success: self.updateFilesList
																		});
																} else
																		Ext.Msg.show({
																				buttons: Ext.Msg.OK, 
																				icon: Ext.Msg.ERROR,
																				iconCls: '',
																				title: ~'Помилка'~,
																				msg: ~'Ім\'я файла чи директорії має складатись з літер, цифр та знаків: \'_\', \'-\', \'.\''~
																		});
														}
												}
										});
								}
						}),
						unzip: new Ext.Action({
								disabled: true,
								icon: 'images/icons/compress.png',
								tooltip: ~'Розархівувати виділені архіви'~,
								handler: function(){
										var i, r = self.gridFiles.getSelectionModel().getSelected();
										Ext.Ajax.request({
												params: {
														cmd: 'unzip',
														dir: self.fmCurState.dir,
														f: self.fmCurState.dir + '/' + r.data.name
												},
												success: self.updateFilesList
										});
								}
						}),
						search:	new Ext.Action({
								disabled: true,
								iconCls: 'x-action-search',
								handler: function(){
										if (!self.winSearch) {
												self.winSearch = new Ext.Window({
														title: ~'Пошук файлів'~,
														modal: true,
														width: 400,
														autoHeight: true,
														iconCls: 'x-action-search',
														closeAction: 'hide',
														items: [{
																xtype: 'form',
																frame: true,
																labelWidth: 180,
																items: [{
																		xtype: 'textfield',
																		fieldLabel: ~'Регулярний вираз'~,
																		name: 'regex',
																		anchor: '100%',
																		id: 'tf-reg-exp'
																},{
																		xtype: 'numberfield',
																		fieldLabel: ~'Змінений днів тому'~,
																		name: 'modified',
																		minValue: 0,
																		width: 50,
																		id: 'tf-modified'
																},{
																		xtype: 'numberfield',
																		fieldLabel: ~'Використовувався днів тому'~,
																		name: 'used',
																		minValue: 0,
																		width: 50,
																		id: 'tf-access'
																}]
														}],
														buttons: [{
																text: ~'Шукати'~,
																handler: function(){
																	 var a = Ext.getCmp('tf-access').getValue(), 
																		    m = Ext.getCmp('tf-modified').getValue(),
																						e = Ext.getCmp('tf-reg-exp').getValue();
																	 if (a || m || e) {
																		  self.refresh({action: 'goto', 
																		  													 dir: self.fmCurState.dir, 
																		  														search: { 
																		  														  atime: a,
																		  														  mtime: m,
																		  														  expr: e
																		  														}
																		  												});
																		  self.winSearch.hide();															
																		} else
																		  Ext.MessageBox.alert(~'Пошук'~, ~'Введіть параметри пошуку'~);
																}
														},{
																text: ~'Скасувати'~,
																handler: function(){
																		self.winSearch.hide();
																}
														}]
												})
										}
										self.winSearch.show();
								}
						}),
						rename: new Ext.Action({
								disabled: true,
								icon: 'images/icons/textfield_rename.png',
								tooltip: ~'Перейменувати'~,
								handler: function(){								
										self.gridFiles.startEditing(self.gridFiles.getStore().indexOf(self.gridFiles.getSelectionModel().getSelected()), 2);
								}
						}),
						attributes: new Ext.Action({
								disabled: true,
								iconCls: 'x-action-attributes',
								tooltip: ~'Атрибути'~,
								handler: function(){
										if (!self.winFileAttributes) {
												self.winFileAttributes = new app.AttrWindow();
												self.winFileAttributes.on('saveattributes', function(files, mode, recursive){
														var fs = [], i;
								      self.fmActions.disable();
														for (i = 0; i < files.length; i++)
										      fs.push(self.fmCurState.dir + '/' + files[i].data['name']);
												  Ext.Ajax.request({
														  params: {
																	 cmd: 'chmod',
																		dir: self.fmCurState.dir,
																		'files[]': fs,
																		mode: mode,
																		recursive: recursive
																},
																success: self.updateFilesList
														});
												});
										}
										self.winFileAttributes.show();							
										self.winFileAttributes.setUp(self.gridFiles.getSelectionModel().getSelections(), self.fmCurState.dir);
								}
						}),
						copy: new Ext.Action({
								disabled: true,
								icon: 'images/filemanager/tool_copy.gif',
								tooltip: ~'Скопіювати'~,
								handler: function(){
										var i, rs = self.gridFiles.getSelectionModel().getSelections();
										self.fmClipboard.length = 0;
										for (i = 0; i < rs.length; i++) 
												self.fmClipboard.push(self.fmCurState.dir + '/' + rs[i].data['name']);
										self.fmClipboardAction = 'cp';
										self.fmActions.paste.enable();
								}
						}),
						cut: new Ext.Action({
								disabled: true,
								icon: 'images/filemanager/tool_cut.gif',
								tooltip: ~'Вирізати'~,
								handler: function(){
										var i, rs = self.gridFiles.getSelectionModel().getSelections();
										self.fmClipboard.length = 0;
										for (i = 0; i < rs.length; i++) 
												self.fmClipboard.push(self.fmCurState.dir + '/' + rs[i].data['name']);
										self.fmClipboardAction = 'mv';	
										self.fmActions.paste.enable();													
								}
						}),
						paste: new Ext.Action({
								disabled: true,
								icon: 'images/filemanager/tool_paste.gif',
								tooltip: ~'Вставити'~,
								handler: function(){
										Ext.Ajax.request({
												params: {
														cmd: self.fmClipboardAction,
														dir: self.fmCurState.dir,
														'source[]': self.fmClipboard,
														target: self.fmCurState.dir
												}, 
												success: self.updateFilesList
										});
								}
						}),
						view: new Ext.Action({
								disabled: true,
								iconCls: 'x-action-view',
								tooltip: ~'Перегляд файла'~,
								handler: function(file_name, new_file){									 
										if (!self.winViewer) 
												self.winViewer = new app.ViewerWindow({
												  fm: self
												});
										
										if (!file_name || Ext.isObject(file_name)) {
											 var r = self.gridFiles.getSelectionModel().getSelected();
												file_name = r.data.name;
										}
										var o = {
												middleware: self.fmCurState.middleware, 
												dir: self.fmCurState.middleware ? 
												     self.fmCurState.grid_task_id + '/' + self.fmCurState.grid_dir + (self.fmCurState.grid_dir ? '/' : '') :
																	self.fmCurState.dir + '/', 
												file_name: file_name
										};
										self.winViewer.viewFile(o, new_file);										
								}				
						}),
						download: new Ext.Action({
						  disabled: true,
								iconCls: 'x-action-download',
								tooltip: ~'Скачати файл'~,
								handler: function() {
								  var r = self.gridFiles.getSelectionModel().getSelected(),
										    f = (self.fmCurState.middleware ? 
														       self.fmCurState.grid_task_id + '/' + self.fmCurState.grid_dir + (self.fmCurState.grid_dir ? '/' : '') :
																					self.fmCurState.dir + '/') + r.data.name;
										try {
												Ext.destroy(Ext.get('iframe-download'));
										}
										catch(e) {}
										Ext.DomHelper.append(document.body, {
										 	tag: 'iframe',
												id: 'iframe-download',
												frameBorder: 0,
												width: 0,
												height: 0,
												css: 'display:none;visibility:hidden;height:0px;',
												src: 'modules/_.php?cmd=get&action=download&f=' + f + '&m=' + (self.fmCurState.middleware || '')
										});
        }
						}),
						disable: function() {
								self.sbFiles.showBusy();
								for (var i in this)
										if (this[i].isAction)
												this[i].disable();
						},
						enable: function() {
								var r, unzip_disable = true, view_disable = true, download_disable = true, sel_count = self.gridFiles.getSelectionModel().getCount();
								if (sel_count == 1) {
										r = self.gridFiles.getSelectionModel().getSelected();
										unzip_disable = r.data['is_dir'] || ['.7z','.bz2','.gz','.rar','.tar','.tgz','.zip'].indexOf(r.data['type']) == -1;
										view_disable = r.data['is_dir'];// || !self.fileViewable(r.data['type']);
										download_disable = r.data['is_dir'];
								}
								this.attributes.setDisabled(sel_count == 0);
								this.back.setDisabled(self.btnBack.menu.items.getCount() == 0);
								this.copy.setDisabled(sel_count == 0);      
								this.cut.setDisabled(sel_count == 0);
								this.del.setDisabled(sel_count == 0);
								this.download.setDisabled(download_disable);
								this.forward.setDisabled(self.btnForward.menu.items.getCount() == 0);
								this.goto.enable();
								this.home.enable();
								this.newFile.enable();
								this.newFolder.enable();
								this.paste.setDisabled(self.fmClipboard.length == 0);
								this.refresh.enable();
								this.rename.setDisabled(sel_count != 1);
								this.search.enable();
								this.unzip.setDisabled(unzip_disable);
								this.up.enable();
								this.upload.enable();
								this.view.setDisabled(view_disable);
								this.zip.setDisabled(sel_count == 0);							
						}
				};
				
				//this.fileViewable = function(extension) {
				//	 return ['.txt','.log','.bat','.jpg','.jpeg','.gif','.png','.zip','.bz2','.tar','.gz','.rar'].indexOf(extension) > -1
			//	}
				
				this.storeFiles = new app.storeFiles({
						fields: [{
								name: 'middleware',
								defaultValue: '',
								mapping: 'm'
					 },{
							 name: 'grid_task_id',
								mapping: 'g'
						},{
								name: 'type', // = extension
								defaultValue: ''
						}, {
								name: 'is_dir',
								mapping: 'd',
								type: 'boolean'
						}, {
								name: 'name',
								mapping: 'f'
						}, {
								name: 'size',
								mapping: 's',
								type: 'int'
						}, {		
								name: 'date',
								mapping: 't',
								type: 'date',
								dateFormat: 'U'
						}, {
								name: 'mode',
								mapping: 'r'
						}, {
								name: 'owner',
								mapping: 'o'		 
						}]
				});
				
				this.smFiles = new Ext.grid.CheckboxSelectionModel({
						moveEditorOnEnter: false,
						listeners: {
								selectionchange: function(sm){
										self.fmActions.enable()
								}
						} 
				})
				
				this.sbFiles = new Ext.ux.StatusBar({
						busyText: ~'Завантаження...'~,
						items: [{
														
						}]
				});
				
				this.menuFmGridContext = new Ext.menu.Menu({
						items: [this.fmActions.view, this.fmActions.download, {
								text: ~'Використати як файл для виконання'~,
								handler: function(){
								
								}
						}, {
								text: ~'Додати до параметрів задачі'~,
								handler: function(){
								
								}
						}, this.fmActions.rename, '-', 
						this.fmActions.cut, this.fmActions.copy, this.fmActions.paste, '-',  
						this.fmActions.zip, this.fmActions.unzip, '-', this.fmActions.attributes],
						listeners: {
								render: function(){
										var i, t, c;
										for (var i = 0; i < this.items.length; i++){
												c = this.get(i);
												t = c.tooltip || '';
												if (t)
														c.setText(t);
										}
								}
						}
				})
				
				this.tfCurrentDir = new Ext.form.TextField({
						width: 400
				});
				
				this.btnBack = new Ext.SplitButton(this.fmActions.back);
				this.btnForward = new Ext.SplitButton(this.fmActions.forward);
					
				this.gridFiles = new Ext.grid.EditorGridPanel({
						ddGroup: 'gridFilesDD',
						enableDragDrop: true,
						region: 'center',
						store: this.storeFiles,
						border: false,
						stripeRows: true,										
						clicksToEdit: 2,
						stateful: true,
						stateId: 'gridFiles',
						colModel: new Ext.grid.ColumnModel({
								defaults: {
										sortable: true
								},
								columns: [this.smFiles, {
										xtype: 'actioncolumn',
										header: ~'Тип'~,
										width: 40,
										dataIndex: 'type',
										items: [{
												getClass: function(v, meta, r) {
														var d = r.data.is_dir, t = r.data.type, m = r.data.middleware;
														var cl = (m > '' && d) ? 'grid-dir' : (d ? 'dir' : self.fileTypeClasses[t]);
														return 'filetype-' + (cl > '' ? cl : self.defaultFileTypeClass);
												},
												handler: function(grid, rowIndex, colIndex) {
														var r = grid.getStore().getAt(rowIndex), 
														    m = r.data.middleware || self.fmCurState.middleware;

              if (r.data.is_dir) {
														  if (m) { // goto grid folder
																  self.refresh({
																				middleware: m, 
																				grid_task_id: r.data.grid_task_id || self.fmCurState.grid_task_id,
																				grid_task: self.fmCurState.grid_task || r.data.name,
																				grid_dir: self.fmCurState.middleware ? (self.fmCurState.grid_dir ? self.fmCurState.grid_dir + '/' : '') + r.data.name : ''
																	 });
																} else // goto folder
																		self.refresh({dir: self.fmCurState.dir + '/' + r.data.name});
														} else {
																//if (self.fileViewable(r.data['type'])) {// view file
																grid.getSelectionModel().selectRow(rowIndex, false, false);
																self.fmActions.view.execute();
														} 
												}
										}]
								},{
										header: ~'Ім\'я файла'~,
										dataIndex: 'name',
										width: 300,
										editor: new Ext.form.TextField({
												allowBlank: false,
												vtype: 'filename'
										})								
								},{
										header: ~'Розмір'~,
										dataIndex: 'size',
										renderer: Ext.util.Format.fileSize								
								},{
										header: ~'Час зміни'~,
										dataIndex: 'date',
										xtype: 'datecolumn',
										format: 'd.m.Y H:i:s',
										width: 130
								},{
										header: ~'Користувач'~,
										dataIndex: 'owner'
								},{
										header: ~'Права'~,
										dataIndex: 'mode',
										renderer: this.fileModeFormat
								}]
						}),
						viewConfig: {
							 forceFit: true
						},						
						sm: this.smFiles,
						tbar: {
								items: [/*{
								  xtype: 'combo',
										store: new Ext.data.ArrayStore({fields: ['host'], data: [['local'], ['remote 1'], ['remote 2']]}),
										displayField: 'host',
										valueField: 'host',
										mode: 'local',
										triggerAction: 'all',
										value: 'local'
								}, '-',	*/
								this.fmActions.refresh, this.fmActions.up, this.fmActions.home, '-', this.fmActions.cut, this.fmActions.copy, this.fmActions.paste, '-',  
								this.fmActions.newFile, this.fmActions.newFolder, this.fmActions.del, '-', 
								this.fmActions.download, this.fmActions.upload, this.fmActions.zip, this.fmActions.unzip, '-', 
								this.fmActions.attributes, this.fmActions.search, '-',
								this.btnBack, this.btnForward,	this.tfCurrentDir, this.fmActions.goto]
						},
						bbar: this.sbFiles,
						listeners: {
								afteredit: function(e){
										Ext.Ajax.request({
												params: {
														cmd: 'mv',
														dir: self.fmCurState.dir,
														source: self.fmCurState.dir + '/' + e.originalValue,
														target: self.fmCurState.dir + '/' + e.value
												},
												success: self.updateFilesList
										});
								},
								rowcontextmenu: function(grid, rowIndex, e){
										var sm = grid.getSelectionModel();
										if (!sm.isSelected(rowIndex))
												sm.selectRow(rowIndex);
										e.stopEvent();
										self.menuFmGridContext.showAt(e.xy);
								}
						}
				});
    				
				this.profilesPanel = new app.ProfilesPanel({
						interface: this.interface,
				  listeners: {
							 readprofile: function(profile) {
									 self.formLaunch.setProfile(profile);
								}
						}
    });
				
				this.formLaunch = new app.LaunchForm({
						fm: this, // link to filemanager object
						iconCls: 'x-tab-fm',
						listeners: {
							 saveprofile: function(profile) {
								  self.profilesPanel.saveProfile(profile);
								}
						}
				});
				
				this.panelLog = new Ext.Panel({
			   iconCls: 'x-mon-log',																																		
				  region: 'south',
						height: 100,
						collapsible: true,
						title: ~'Журнал запусків'~,
						autoScroll: true,
						tpl: '<div>{r}</div>',
						tplWriteMode: 'append',
						bodyStyle: 'padding: 5px'
				});
				
				var config = {
						title: ~'Запуск задач'~,
						layout: 'border',
						items: [this.gridFiles, {
								region: 'south',
								layout: 'border',
								height: 470,
								bodyBorder: false,
								items: [this.formLaunch, this.profilesPanel, this.panelLog]
						}]
				};
				
				Ext.applyIf(this, config);

    app.FileManager.superclass.initComponent.call(this);

		}
});