app.TabGridMap = Ext.extend(Ext.BoxComponent, {
		initComponent: function () {

    var config = {
				  infowindow: new google.maps.InfoWindow(),
      zoomLevel: 4,
      gmapType: 'map',
      border: false
    };

    Ext.applyIf(this, config);

    app.TabGridMap.superclass.initComponent.call(this);

  },
		
		markerClick: function(){
				var d = this.interface.storeClusters.getAt(this.id).data;
				this.infowindow.setContent('<h3>' + d.hostname + '</h3><p>' + d.organization + ',<br>' + d.country + ', ' + 
																															d.city + ',<br>' + d.location + ', ' + d.address + '</p>');
				self.infowindow.open(this.getMap(), this);
		},								
  
		clearClusters: function(store) {
				var i, d;
				for (i = 0; i < store.getCount(); i++) {
						d = store.getAt(i).data;
						if (d.marker) {
								d.marker.setMap(null);
								d.marker = null;
								store.getAt(i).commit();
						}
				}								  
		},
		
		addClusters: function(store){
				var i, d, o, r;
				for (i = 0; i < store.getCount(); i++) {
					 r = store.getAt(i);
						d = r.data
						
						if (d.geo_lat != null && d.geo_lng != null) {
								o = {
										map: this.gmap,
										position: new google.maps.LatLng(d.geo_lat, d.geo_lng),
										title: d.hostname,
										id: i
								};
								if (d.avail == 'up') {
										o.icon = 'images/map/marker_green.png';
										o.shadow = {url: 'https://maps.gstatic.com/mapfiles/ms2/micons/msmarker.shadow.png', anchor: new google.maps.Point(14, 34)}
								}
								d.marker = new google.maps.Marker(o);
								google.maps.event.addListener(d.marker, 'click', this.markerClick);
						}
						r.commit();
				}			
		},
		
  afterRender: function () {

    var wh = this.ownerCt.getSize();
    Ext.applyIf(this, wh);

    app.TabGridMap.superclass.afterRender.call(this);

    this.gmap = new google.maps.Map(this.getEl().dom, {
      mapTypeId: google.maps.MapTypeId.ROADMAP,
      panControl: false,
      streetViewControl: false,
      zoom: this.zoomLevel
    });

    if (typeof this.setCenter === 'object') {
      var point = new google.maps.LatLng(this.setCenter.lat, this.setCenter.lng);
      this.gmap.setCenter(point);
    }

    google.maps.event.addListener(this.gmap, 'load', this, function () {
      this.onMapReady();
    });
    
				this.interface.storeClusters.on('beforeload', this.clearClusters);
				
				this.interface.storeClusters.on('load', this.addClusters, this);			
				
				this.addClusters(this.interface.storeClusters);
				
				//this.interface.storeClusters.load();
  },
		
  onMapReady: function () {

  },
  
		onResize: function (w, h) {

    if (typeof this.getMap() == 'object') {
      google.maps.event.trigger(this.gmap, 'resize');
    }

    app.TabGridMap.superclass.onResize.call(this, w, h);

  },
  setSize: function (width, height, animate) {

    if (typeof this.getMap() == 'object') {
      google.maps.event.trigger(this.gmap, 'resize');
    }

    app.TabGridMap.superclass.setSize.call(this, width, height, animate);

  },
  getMap: function () {

    return this.gmap;

  },
  getCenter: function () {

    return this.getMap().getCenter();

  }
});