Ext.onReady(function () {
		
		Ext.Ajax.url = 'modules/login.php';
		Ext.Ajax.method = 'post';
  
		Ext.QuickTips.init();
 
	 log_in = function () {
				login.getForm().submit({
						waitTitle: ~'Підключення'~,
						waitMsg: ~'Перевірка даних...'~,
						success: function () {
								window.location = '/';
						},
						failure: function (form, action) {
								var errors = {'blocked': ~'Ваш обліковий запис заблоковано.'~, 
																						'wrong': ~'Введені облікові дані користувача є помилковими.'~};
								
								Ext.Msg.show({
										title: ~'Помилка входу'~, 
										msg: errors[action.result.error],
										icon: Ext.Msg.ERROR,
										buttons: Ext.Msg.OK
								});
								login.getForm().reset();
						}
				});
		}
	 
  var login = new Ext.FormPanel({
    frame: true,
    title: ~'Увійти до системи керуванння кластером'~,
    defaultType: 'textfield',
    monitorValid: true,
				labelWidth: 120,
				baseParams: {
					 action: 'log_in'
				},
				defaults: {
				  anchor: '100%'
				},
    items: [new Ext.ux.IconCombo({
				  fieldLabel: ~'Мова інтерфейсу'~,
						store: new Ext.data.ArrayStore({
								fields: ['id', 'n', 'cls'],
								data: languages
						}),
						displayField: 'n',
						valueField: 'id',
						iconClsField: 'cls',
						mode: 'local',
						editable: false,
						forceSelection: true,
						triggerAction: 'all',
						hiddenName: 'language_id',
						value: language_id,
						listeners: {
						  select: function(){
								  window.location = '/?language_id=' + this.getValue();
								}
						}
				}),{
      fieldLabel: ~"Ім'я користувача"~,
      name: 'login',
      allowBlank: false,
      blankText: ~'Введіть ім\'я користувача'~						
    }, {
      fieldLabel: ~'Пароль'~,
      name: 'pass',
      inputType: 'password',
      allowBlank: false,
						blankText: ~'Введіть пароль'~
    }],
    buttons: [{
      text: '<b>'+~'Увійти'~+'</b>',
      formBind: true,
      handler: log_in
    }],
				listeners: {
						afterrender: function(){
							 new Ext.KeyMap(this.getEl(), {
								  key: [10, 13],
										scope: this,
										fn: function(){
											 if(this.getForm().isValid())
												  log_in()
										}
        });
						}
				}				
  });

		
  var winLogin = new Ext.Window({
    width: 330,
				autoHeight: true,
    closable: false,
    resizable: false,
    plain: true,
    border: false,
    items: [login],
				listeners: {
					 afterrender: function(){
						  var e = Ext.get('loading');
        if (e)
				      e.remove();	
						}
				}
  });
		
  winLogin.show();
});