app.ProfilesPanel = Ext.extend(Ext.grid.GridPanel, {
		title: ~'Профілі'~,
		iconCls: 'x-panel-profiles',
		width: 240,
		region: 'east',
  
		loadProfiles: function(profiles) {
			 this.storeProfiles.loadData(profiles);
		},
		
		saveProfile: function(profile) {
			 profile.cmd = 'save_profile';
				if (profile.login === false)
				  profile.login = this.interface.userSettings.work_login;
			 Ext.Ajax.request({
						params: profile,
						success: this.decodeLoadProfiles
				});
		},
		
  initComponent: function(){
				var self = this;
			 
				this.decodeLoadProfiles = function(response, opts){
						var o = response.responseJSON;
						self.loadProfiles(o.profiles || []);
				};
				
				this.storeProfiles = new Ext.data.JsonStore({
						url: 'modules/_.php',
						baseParams: {
								cmd: 'profiles'
						},
						method: 'post',
						fields: ['login', 'title', 'profile', 'description']			
				});
								
				var config = {
						stripeRows: true,
						store: this.storeProfiles,
						columns: [{
								header: ~'Профіль'~,
								dataIndex: 'title',
								menuDisabled: true,
								renderer: function(value, metadata, record) {
									 metadata.attr = 'ext:qtip="' + record.get('description') + '"';
          return value;
								}
						},{
							 xtype: 'actioncolumn',
								menuDisabled: true,
								width: 18,
								items: [{
										getClass: function(v, meta, rec){
												var g = !rec.get('login'); // global = no login
												meta.attr = 'ext:qtip="' + (g ? ~'Глобальний профіль'~ : ~'Ваш особистий профіль'~) + '"';
												return 'x-action-global' + (g ? '' : ' disabled') + (self.interface.userSettings.is_admin ? '' : ' click-disable');
										},
										handler: function(grid, rowIndex, colIndex) {
											 if (!self.interface.userSettings.is_admin)
												  return;
												var r = grid.getStore().getAt(rowIndex);
											 Ext.Ajax.request({
												  params: {
															 cmd: 'save_profile',
																login: r.get('login'),
																title: r.get('title'),
																description: r.get('description'),
																global: r.get('login') ? 1 : 0
														},
        						success: self.decodeLoadProfiles
												});
										}
								}]
						},{
							 xtype: 'actioncolumn',
								menuDisabled: true,
								width: 18,
								items: [{
										getClass: function(v, meta, rec){
												var g = !rec.get('login');												
												meta.attr = 'ext:qtip="' + ((!g || self.interface.userSettings.is_admin) ? ~'Видалити профіль'~ : ~'Немає прав для видалення'~) + '"';
												return (!g || self.interface.userSettings.is_admin) ? 'x-action-delete' : 'click-disable';
										},			 
										handler: function(grid, rowIndex, colIndex) {
												var r = grid.getStore().getAt(rowIndex);
												if (!r.get('login') && !self.interface.userSettings.is_admin)
												  return;											
												Ext.Ajax.request({
												  params: {
															 cmd: 'delete_profile',
																login: r.get('login'),
																title: r.get('title')
														},
        						success: self.decodeLoadProfiles
												});											
										}
								}]
						}],
						sm: new Ext.grid.RowSelectionModel({
								singleSelect: true
						}),
						viewConfig: {
								forceFit: true
						},
						listeners: {
								rowdblclick: function (grid, index, e) {
										// fill in the launch form with the selected profile
										var r = grid.getStore().getAt(index);
										var profile = r.get('profile');
										profile.task_name = r.get('title');
										profile.login = r.get('login');
										profile.description = r.get('description');
										self.fireEvent('readprofile', profile);
								}
						}
				};
				
				
		  Ext.applyIf(this, config);

    app.ProfilesPanel.superclass.initComponent.call(this);
				
				this.addEvents('readprofile');
				
		}
});