app.ResourcesPanel = Ext.extend(Ext.Container, {
		title: ~"Ресурси"~,
		iconCls: 'x-tab-resources',

  loadResources: function(grid_resources){
		  Ext.Ajax.request({
				  params: {
						  cmd: 'resources',
								details: this.details ? 1 : 0,
								grid_resources: grid_resources == true ? 1 : 0
						},
						scope: this,
						success: function (response, opts) {
								var i, s, d, a = [], b = [],	o = response.responseJSON;
										
								this.storeResources.loadData(o.resources || {});
								this.storeResources.loadData(o.grid_resources || {}, true);
								
								for (i = 0; i < this.storeResources.getCount(); i++) {								  
										d = this.storeResources.getAt(i).data;
										if (d.available == 'up') {
										  s = d.partition + ' @ ' + d.hostname;
										  if (a.indexOf(s) == -1) {												
										    a.push(s);
														b.push([s, d.middleware]);
												}		
										} 
								}
								this.fireEvent('partitionschange', b);
						}
				});
		},
  
  initComponent: function(){
		  var self = this;
				
				this.details = false;
				
				this.storeResources = new Ext.data.GroupingStore({
						groupField: 'hostname',
						reader: new Ext.data.JsonReader({
								fields: [{
										name: 'hostname',
										mapping: 'H',
										defaultValue: ''
								},{
										name: 'middleware',
										mapping: 'M'
								},{
										name: 'partition', 
										mapping: 'P'
								},{
										name: 'available',
										mapping: 'a'
								},{
										name: 'time_limit', 
										mapping: 'l'
								},{
										name: 'status', 
										mapping: 't'
								},{
										name: 'cores_per_node', 
										mapping: 'c'
								},{
										name: 'memory_per_node', 
										mapping: 'm'
								},{
										name: 'nodes_count',
										mapping: 'D',
										type: 'int'
								},{
										name: 'cores_count',
										mapping: 'C',
										type: 'int'
								},{
										name: 'nodes', 
										mapping: 'N'
								},{
										name: 'reason',
										mapping: 'E'
								},{
										name: 'max_job_size',
										mapping: 's'				
								},{
										name: 'global', 
										mapping: 'g'				
								},{
										name: 'features', 
										mapping: 'f'
								},{
										name: 'location',
										mapping: 'L'
								}]				
						})
				});		
				
				var resoursesStatuses = {'up': ~'Доступний'~, 'down': ~'Недоступний'~, 'fail': ~'Помилка'~};
				// classes to color resources panel
				var resources_cls = {'down': 'resource-down', 
																									'down*': 'resource-down-star',
																									'idle': 'resource-idle',
																									'drain': 'resource-drain',
																									'drain*': 'resource-drain-star'};
								
				this.gridResources = new Ext.grid.GridPanel({
						region: 'center',																																										
						store: this.storeResources,
						colModel: new Ext.grid.ColumnModel({
								defaults: {
										sortable: true
								},
								columns: [{
										header: ~'Кластер'~,
										dataIndex: 'hostname'
								},{
										header: ~'Розділ'~,
										dataIndex: 'partition'
								},{
										header: ~'Стан'~,
										dataIndex: 'status',
										width: 50,
										renderer: function(value, metaData) {
												metaData.css = resources_cls[value];
												return value;
										}
								},{
										header: ~'Вузлів'~,
										dataIndex: 'nodes_count',
										align: 'right',
										width: 40
								},{
										header: ~'Ядер'~,
										dataIndex: 'cores_count',
										align: 'right',
										width: 40
								},{
										header: ~'Ліміт часу'~,
										dataIndex: 'time_limit',
										align: 'right',
										renderer: Ext.util.Format.periodFormat,
										width: 100
								},{
										header: ~'Доступний'~,
										dataIndex: 'available',
										align: 'center',
										renderer: function(x){
												var r = resoursesStatuses[x];
												return Ext.isDefined(r) ? r : x;
										}
								}]
						}),
						stripeRows: true,
						view: new Ext.grid.GroupingView({
								forceFit: true,
								hideGroupedColumn: true
						}),
						sm: new Ext.grid.RowSelectionModel({
								singleSelect: true,
								listeners: {
										rowselect: function (sm, rowIdx, r) {
												self.panelInfo.update(r.data);
										}
								}
						}),
						tbar: [{
								text: ~'Оновити'~,
								iconCls: 'x-action-refresh',
								scope: this,
								handler: self.loadResources
						},{
								text: ~'Докладно'~,
								iconCls: 'x-action-details',
								enableToggle: true,
								handler: function(b) {
									 self.panelInfo.setVisible(b.pressed);
										self.loadResources();
								}
						}]
				});
				
				this.panelInfo = new Ext.Panel({
						region: 'south',
						iconCls: 'x-action-details',
						title: ~"Додаткова інформація"~,
						height: 200,
						collapsible: true,
						minSize: 150,
						split: true,
						bodyStyle: {
								padding: '7px'
						},
						autoScroll: true,
						tpl: ['<table cellspacing="0" cellpadding="2" border="0">',
								'<tr><td>Кластер:</td><td> {hostname}<br />',
								'<tr><td>Розташування:</td><td> {location}<br />',
								'<tr><td>Розділ:</td><td> {partition} ({global})<br />', // local-global
								'<tr><td width="150">Доступний: </td><td> {available}</td></tr>',
								'<tr><td>Обмеження часу: </td><td> {time_limit:periodFormat}</td></tr>',
								'<tr><td>Стан вузлів: </td><td> {status}</td></tr>',
								'<tr><td>Кількість вузлів: </td><td> {nodes_count}</td></tr>',
								'<tr><td>Кількість ядер: </td><td> {cores_count}</td></tr>',
								'<tr><td>Кількість ядер на вузлі: </td><td> {cores_per_node}</td></tr>',
								'<tr><td>Об\'єм пам\'яті на вузлі: </td><td> {memory_per_node}</td></tr>',
								'<tr><td valign="top">Список вузлів: </td><td> {nodes}</td></tr>',
								'<tr><td>Властивості: </td><td> {features}</td></tr>',             // якщо немає даних - не показувати
								'<tr><td>Причина відмови: </td><td> {reason}</td></tr></table>'] 	// причина відмови - тільки для адміна, пусто не показувати взагалі
				});
				
				var config = {
					 layout: 'border',
						items: [this.gridResources, this.panelInfo]						
				};
				
    Ext.applyIf(this, config);

    app.ResourcesPanel.superclass.initComponent.call(this);		
				
				this.addEvents('partitionschange');
				
		}
});